<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumCnxManager.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">QuorumCnxManager.java</span></div><h1>QuorumCnxManager.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.nio.BufferUnderflowException;
import java.nio.ByteBuffer;
import java.nio.channels.UnresolvedAddressException;
import java.util.Enumeration;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.TimeUnit;
import java.util.NoSuchElementException;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.server.ZooKeeperServer;
import org.apache.zookeeper.server.ZooKeeperThread;

/**
 * This class implements a connection manager for leader election using TCP. It
 * maintains one connection for every pair of servers. The tricky part is to
 * guarantee that there is exactly one connection for every pair of servers that
 * are operating correctly and that can communicate over the network.
 * 
 * If two servers try to start a connection concurrently, then the connection
 * manager uses a very simple tie-breaking mechanism to decide which connection
 * to drop based on the IP addressed of the two parties. 
 * 
 * For every peer, the manager maintains a queue of messages to send. If the
 * connection to any particular peer drops, then the sender thread puts the
 * message back on the list. As this implementation currently uses a queue
 * implementation to maintain messages to send to another peer, we add the
 * message to the tail of the queue, thus changing the order of messages.
 * Although this is not a problem for the leader election, it could be a problem
 * when consolidating peer communication. This is to be verified, though.
 * 
 */

public class QuorumCnxManager {
<span class="fc" id="L66">    private static final Logger LOG = LoggerFactory.getLogger(QuorumCnxManager.class);</span>

    /*
     * Maximum capacity of thread queues
     */
    static final int RECV_CAPACITY = 100;
    // Initialized to 1 to prevent sending
    // stale notifications to peers
    static final int SEND_CAPACITY = 1;

    static final int PACKETMAXSIZE = 1024 * 512; 
    /*
     * Maximum number of attempts to connect to a peer
     */

    static final int MAX_CONNECTION_ATTEMPTS = 2;

    /*
     * Max buffer size to be read from the network.
     */
    static public final int maxBuffer = 2048;
    
    /*
     * Negative counter for observer server ids.
     */
    
<span class="fc" id="L92">    private long observerCounter = -1;</span>
    
    /*
     * Connection time out value in milliseconds 
     */
    
<span class="fc" id="L98">    private int cnxTO = 5000;</span>
    
    /*
     * Local IP address
     */
    final QuorumPeer self;

    /*
     * Mapping from Peer to Thread number
     */
    final ConcurrentHashMap&lt;Long, SendWorker&gt; senderWorkerMap;
    final ConcurrentHashMap&lt;Long, ArrayBlockingQueue&lt;ByteBuffer&gt;&gt; queueSendMap;
    final ConcurrentHashMap&lt;Long, ByteBuffer&gt; lastMessageSent;

    /*
     * Reception queue
     */
    public final ArrayBlockingQueue&lt;Message&gt; recvQueue;
    /*
     * Object to synchronize access to recvQueue
     */
<span class="fc" id="L119">    private final Object recvQLock = new Object();</span>

    /*
     * Shutdown flag
     */

<span class="fc" id="L125">    volatile boolean shutdown = false;</span>

    /*
     * Listener thread
     */
    public final Listener listener;

    /*
     * Counter to count worker threads
     */
<span class="fc" id="L135">    private AtomicInteger threadCnt = new AtomicInteger(0);</span>

    static public class Message {
        
<span class="fc" id="L139">        Message(ByteBuffer buffer, long sid) {</span>
<span class="fc" id="L140">            this.buffer = buffer;</span>
<span class="fc" id="L141">            this.sid = sid;</span>
<span class="fc" id="L142">        }</span>

        ByteBuffer buffer;
        long sid;
    }

<span class="fc" id="L148">    public QuorumCnxManager(QuorumPeer self) {</span>
<span class="fc" id="L149">        this.recvQueue = new ArrayBlockingQueue&lt;Message&gt;(RECV_CAPACITY);</span>
<span class="fc" id="L150">        this.queueSendMap = new ConcurrentHashMap&lt;Long, ArrayBlockingQueue&lt;ByteBuffer&gt;&gt;();</span>
<span class="fc" id="L151">        this.senderWorkerMap = new ConcurrentHashMap&lt;Long, SendWorker&gt;();</span>
<span class="fc" id="L152">        this.lastMessageSent = new ConcurrentHashMap&lt;Long, ByteBuffer&gt;();</span>
        
<span class="fc" id="L154">        String cnxToValue = System.getProperty(&quot;zookeeper.cnxTimeout&quot;);</span>
<span class="fc bfc" id="L155" title="All 2 branches covered.">        if(cnxToValue != null){</span>
<span class="fc" id="L156">            this.cnxTO = new Integer(cnxToValue); </span>
        }
        
<span class="fc" id="L159">        this.self = self;</span>

        // Starts listener thread that waits for connection requests 
<span class="fc" id="L162">        listener = new Listener();</span>
<span class="fc" id="L163">    }</span>

    /**
     * Invokes initiateConnection for testing purposes
     * 
     * @param sid
     */
    public void testInitiateConnection(long sid) throws Exception {
<span class="pc bpc" id="L171" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L172">            LOG.debug(&quot;Opening channel to server &quot; + sid);</span>
        }
<span class="fc" id="L174">        Socket sock = new Socket();</span>
<span class="fc" id="L175">        setSockOpts(sock);</span>
<span class="fc" id="L176">        sock.connect(self.getVotingView().get(sid).electionAddr, cnxTO);</span>
<span class="fc" id="L177">        initiateConnection(sock, sid);</span>
<span class="fc" id="L178">    }</span>
    
    /**
     * If this server has initiated the connection, then it gives up on the
     * connection if it loses challenge. Otherwise, it keeps the connection.
     */
    public boolean initiateConnection(Socket sock, Long sid) {
<span class="fc" id="L185">        DataOutputStream dout = null;</span>
        try {
            // Sending id and challenge
<span class="fc" id="L188">            dout = new DataOutputStream(sock.getOutputStream());</span>
<span class="fc" id="L189">            dout.writeLong(self.getId());</span>
<span class="fc" id="L190">            dout.flush();</span>
<span class="nc" id="L191">        } catch (IOException e) {</span>
<span class="nc" id="L192">            LOG.warn(&quot;Ignoring exception reading or writing challenge: &quot;, e);</span>
<span class="nc" id="L193">            closeSocket(sock);</span>
<span class="nc" id="L194">            return false;</span>
<span class="fc" id="L195">        }</span>
        
        // If lost the challenge, then drop the new connection
<span class="fc bfc" id="L198" title="All 2 branches covered.">        if (sid &gt; self.getId()) {</span>
<span class="fc" id="L199">            LOG.info(&quot;Have smaller server identifier, so dropping the &quot; +</span>
<span class="fc" id="L200">                     &quot;connection: (&quot; + sid + &quot;, &quot; + self.getId() + &quot;)&quot;);</span>
<span class="fc" id="L201">            closeSocket(sock);</span>
            // Otherwise proceed with the connection
        } else {
<span class="fc" id="L204">            SendWorker sw = new SendWorker(sock, sid);</span>
<span class="fc" id="L205">            RecvWorker rw = new RecvWorker(sock, sid, sw);</span>
<span class="fc" id="L206">            sw.setRecv(rw);</span>

<span class="fc" id="L208">            SendWorker vsw = senderWorkerMap.get(sid);</span>
            
<span class="pc bpc" id="L210" title="1 of 2 branches missed.">            if(vsw != null)</span>
<span class="nc" id="L211">                vsw.finish();</span>
            
<span class="fc" id="L213">            senderWorkerMap.put(sid, sw);</span>
<span class="fc bfc" id="L214" title="All 2 branches covered.">            if (!queueSendMap.containsKey(sid)) {</span>
<span class="fc" id="L215">                queueSendMap.put(sid, new ArrayBlockingQueue&lt;ByteBuffer&gt;(</span>
                        SEND_CAPACITY));
            }
            
<span class="fc" id="L219">            sw.start();</span>
<span class="fc" id="L220">            rw.start();</span>
            
<span class="fc" id="L222">            return true;    </span>
            
        }
<span class="fc" id="L225">        return false;</span>
    }

    
    
    /**
     * If this server receives a connection request, then it gives up on the new
     * connection if it wins. Notice that it checks whether it has a connection
     * to this server already or not. If it does, then it sends the smallest
     * possible long value to lose the challenge.
     * 
     */
    public void receiveConnection(Socket sock) {
<span class="fc" id="L238">        Long sid = null;</span>
        
        try {
            // Read server id
<span class="fc" id="L242">            DataInputStream din = new DataInputStream(sock.getInputStream());</span>
<span class="fc" id="L243">            sid = din.readLong();</span>
<span class="fc bfc" id="L244" title="All 2 branches covered.">            if (sid &lt; 0) { // this is not a server id but a protocol version (see ZOOKEEPER-1633)</span>
<span class="fc" id="L245">                sid = din.readLong();</span>

                // next comes the #bytes in the remainder of the message
                // note that 0 bytes is fine (old servers)
<span class="fc" id="L249">                int num_remaining_bytes = din.readInt();</span>
<span class="pc bpc" id="L250" title="2 of 4 branches missed.">                if (num_remaining_bytes &lt; 0 || num_remaining_bytes &gt; maxBuffer) {</span>
<span class="nc" id="L251">                    LOG.error(&quot;Unreasonable buffer length: {}&quot;, num_remaining_bytes);</span>
<span class="nc" id="L252">                    closeSocket(sock);</span>
<span class="nc" id="L253">                    return;</span>
                }
<span class="fc" id="L255">                byte[] b = new byte[num_remaining_bytes];</span>

                // remove the remainder of the message from din
<span class="fc" id="L258">                int num_read = din.read(b);</span>
<span class="pc bpc" id="L259" title="1 of 2 branches missed.">                if (num_read != num_remaining_bytes) {</span>
<span class="nc" id="L260">                    LOG.error(&quot;Read only &quot; + num_read + &quot; bytes out of &quot; + num_remaining_bytes + &quot; sent by server &quot; + sid);</span>
                }
            }
<span class="pc bpc" id="L263" title="1 of 2 branches missed.">            if (sid == QuorumPeer.OBSERVER_ID) {</span>
                /*
                 * Choose identifier at random. We need a value to identify
                 * the connection.
                 */
                
<span class="nc" id="L269">                sid = observerCounter--;</span>
<span class="nc" id="L270">                LOG.info(&quot;Setting arbitrary identifier to observer: &quot; + sid);</span>
            }
<span class="fc" id="L272">        } catch (IOException e) {</span>
<span class="fc" id="L273">            closeSocket(sock);</span>
<span class="fc" id="L274">            LOG.warn(&quot;Exception reading or writing challenge: &quot; + e.toString());</span>
<span class="fc" id="L275">            return;</span>
<span class="fc" id="L276">        }</span>
        
        //If wins the challenge, then close the new connection.
<span class="fc bfc" id="L279" title="All 2 branches covered.">        if (sid &lt; self.getId()) {</span>
            /*
             * This replica might still believe that the connection to sid is
             * up, so we have to shut down the workers before trying to open a
             * new connection.
             */
<span class="fc" id="L285">            SendWorker sw = senderWorkerMap.get(sid);</span>
<span class="fc bfc" id="L286" title="All 2 branches covered.">            if (sw != null) {</span>
<span class="fc" id="L287">                sw.finish();</span>
            }

            /*
             * Now we start a new connection
             */
<span class="fc" id="L293">            LOG.debug(&quot;Create new connection to server: &quot; + sid);</span>
<span class="fc" id="L294">            closeSocket(sock);</span>
<span class="fc" id="L295">            connectOne(sid);</span>

            // Otherwise start worker threads to receive data.
<span class="fc" id="L298">        } else {</span>
<span class="fc" id="L299">            SendWorker sw = new SendWorker(sock, sid);</span>
<span class="fc" id="L300">            RecvWorker rw = new RecvWorker(sock, sid, sw);</span>
<span class="fc" id="L301">            sw.setRecv(rw);</span>

<span class="fc" id="L303">            SendWorker vsw = senderWorkerMap.get(sid);</span>
            
<span class="fc bfc" id="L305" title="All 2 branches covered.">            if(vsw != null)</span>
<span class="fc" id="L306">                vsw.finish();</span>
            
<span class="fc" id="L308">            senderWorkerMap.put(sid, sw);</span>
            
<span class="fc bfc" id="L310" title="All 2 branches covered.">            if (!queueSendMap.containsKey(sid)) {</span>
<span class="fc" id="L311">                queueSendMap.put(sid, new ArrayBlockingQueue&lt;ByteBuffer&gt;(</span>
                        SEND_CAPACITY));
            }
            
<span class="fc" id="L315">            sw.start();</span>
<span class="fc" id="L316">            rw.start();</span>
            
<span class="fc" id="L318">            return;</span>
        }
<span class="fc" id="L320">    }</span>

    /**
     * Processes invoke this message to queue a message to send. Currently, 
     * only leader election uses it.
     */
    public void toSend(Long sid, ByteBuffer b) {
        /*
         * If sending message to myself, then simply enqueue it (loopback).
         */
<span class="fc bfc" id="L330" title="All 2 branches covered.">        if (self.getId() == sid) {</span>
<span class="fc" id="L331">             b.position(0);</span>
<span class="fc" id="L332">             addToRecvQueue(new Message(b.duplicate(), sid));</span>
            /*
             * Otherwise send to the corresponding thread to send.
             */
        } else {
             /*
              * Start a new connection if doesn't have one already.
              */
<span class="fc bfc" id="L340" title="All 2 branches covered.">             if (!queueSendMap.containsKey(sid)) {</span>
<span class="fc" id="L341">                 ArrayBlockingQueue&lt;ByteBuffer&gt; bq = new ArrayBlockingQueue&lt;ByteBuffer&gt;(</span>
                         SEND_CAPACITY);
<span class="fc" id="L343">                 queueSendMap.put(sid, bq);</span>
<span class="fc" id="L344">                 addToSendQueue(bq, b);</span>

<span class="fc" id="L346">             } else {</span>
<span class="fc" id="L347">                 ArrayBlockingQueue&lt;ByteBuffer&gt; bq = queueSendMap.get(sid);</span>
<span class="pc bpc" id="L348" title="1 of 2 branches missed.">                 if(bq != null){</span>
<span class="fc" id="L349">                     addToSendQueue(bq, b);</span>
                 } else {
<span class="nc" id="L351">                     LOG.error(&quot;No queue for server &quot; + sid);</span>
                 }
             }
<span class="fc" id="L354">             connectOne(sid);</span>
                
        }
<span class="fc" id="L357">    }</span>
    
    /**
     * Try to establish a connection to server with id sid.
     * 
     *  @param sid  server id
     */
    
    synchronized void connectOne(long sid){
<span class="fc bfc" id="L366" title="All 2 branches covered.">        if (senderWorkerMap.get(sid) == null){</span>
            InetSocketAddress electionAddr;
<span class="pc bpc" id="L368" title="1 of 2 branches missed.">            if (self.quorumPeers.containsKey(sid)) {</span>
<span class="fc" id="L369">                electionAddr = self.quorumPeers.get(sid).electionAddr;</span>
            } else {
<span class="nc" id="L371">                LOG.warn(&quot;Invalid server id: &quot; + sid);</span>
<span class="nc" id="L372">                return;</span>
            }
            try {

<span class="pc bpc" id="L376" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L377">                    LOG.debug(&quot;Opening channel to server &quot; + sid);</span>
                }
<span class="fc" id="L379">                Socket sock = new Socket();</span>
<span class="fc" id="L380">                setSockOpts(sock);</span>
<span class="fc" id="L381">                sock.connect(self.getView().get(sid).electionAddr, cnxTO);</span>
<span class="pc bpc" id="L382" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L383">                    LOG.debug(&quot;Connected to server &quot; + sid);</span>
                }
<span class="fc" id="L385">                initiateConnection(sock, sid);</span>
<span class="nc" id="L386">            } catch (UnresolvedAddressException e) {</span>
                // Sun doesn't include the address that causes this
                // exception to be thrown, also UAE cannot be wrapped cleanly
                // so we log the exception in order to capture this critical
                // detail.
<span class="nc" id="L391">                LOG.warn(&quot;Cannot open channel to &quot; + sid</span>
                        + &quot; at election address &quot; + electionAddr, e);
                // Resolve hostname for this server in case the
                // underlying ip address has changed.
<span class="nc bnc" id="L395" title="All 2 branches missed.">                if (self.getView().containsKey(sid)) {</span>
<span class="nc" id="L396">                    self.getView().get(sid).recreateSocketAddresses();</span>
                }
<span class="nc" id="L398">                throw e;</span>
<span class="fc" id="L399">            } catch (IOException e) {</span>
<span class="fc" id="L400">                LOG.warn(&quot;Cannot open channel to &quot; + sid</span>
                        + &quot; at election address &quot; + electionAddr,
                        e);
                // We can't really tell if the server is actually down or it failed
                // to connect to the server because the underlying IP address
                // changed. Resolve the hostname again just in case.
<span class="pc bpc" id="L406" title="1 of 2 branches missed.">                if (self.getView().containsKey(sid)) {</span>
<span class="fc" id="L407">                    self.getView().get(sid).recreateSocketAddresses();</span>
                }
<span class="fc" id="L409">            }</span>
<span class="fc" id="L410">        } else {</span>
<span class="fc" id="L411">            LOG.debug(&quot;There is a connection already for server &quot; + sid);</span>
        }
<span class="fc" id="L413">    }</span>
    
    
    /**
     * Try to establish a connection with each server if one
     * doesn't exist.
     */
    
    public void connectAll(){
        long sid;
<span class="fc" id="L423">        for(Enumeration&lt;Long&gt; en = queueSendMap.keys();</span>
<span class="fc bfc" id="L424" title="All 2 branches covered.">            en.hasMoreElements();){</span>
<span class="fc" id="L425">            sid = en.nextElement();</span>
<span class="fc" id="L426">            connectOne(sid);</span>
        }      
<span class="fc" id="L428">    }</span>
    

    /**
     * Check if all queues are empty, indicating that all messages have been delivered.
     */
    boolean haveDelivered() {
<span class="fc bfc" id="L435" title="All 2 branches covered.">        for (ArrayBlockingQueue&lt;ByteBuffer&gt; queue : queueSendMap.values()) {</span>
<span class="fc" id="L436">            LOG.debug(&quot;Queue size: &quot; + queue.size());</span>
<span class="fc bfc" id="L437" title="All 2 branches covered.">            if (queue.size() == 0) {</span>
<span class="fc" id="L438">                return true;</span>
            }
<span class="fc" id="L440">        }</span>

<span class="fc" id="L442">        return false;</span>
    }

    /**
     * Flag that it is time to wrap up all activities and interrupt the listener.
     */
    public void halt() {
<span class="fc" id="L449">        shutdown = true;</span>
<span class="fc" id="L450">        LOG.debug(&quot;Halting listener&quot;);</span>
<span class="fc" id="L451">        listener.halt();</span>
        
<span class="fc" id="L453">        softHalt();</span>
<span class="fc" id="L454">    }</span>
   
    /**
     * A soft halt simply finishes workers.
     */
    public void softHalt() {
<span class="fc bfc" id="L460" title="All 2 branches covered.">        for (SendWorker sw : senderWorkerMap.values()) {</span>
<span class="fc" id="L461">            LOG.debug(&quot;Halting sender: &quot; + sw);</span>
<span class="fc" id="L462">            sw.finish();</span>
<span class="fc" id="L463">        }</span>
<span class="fc" id="L464">    }</span>

    /**
     * Helper method to set socket options.
     * 
     * @param sock
     *            Reference to socket
     */
    private void setSockOpts(Socket sock) throws SocketException {
<span class="fc" id="L473">        sock.setTcpNoDelay(true);</span>
<span class="fc" id="L474">        sock.setSoTimeout(self.tickTime * self.syncLimit);</span>
<span class="fc" id="L475">    }</span>

    /**
     * Helper method to close a socket.
     * 
     * @param sock
     *            Reference to socket
     */
    private void closeSocket(Socket sock) {
        try {
<span class="fc" id="L485">            sock.close();</span>
<span class="nc" id="L486">        } catch (IOException ie) {</span>
<span class="nc" id="L487">            LOG.error(&quot;Exception while closing&quot;, ie);</span>
<span class="fc" id="L488">        }</span>
<span class="fc" id="L489">    }</span>

    /**
     * Return number of worker threads
     */
    public long getThreadCount() {
<span class="fc" id="L495">        return threadCnt.get();</span>
    }
    /**
     * Return reference to QuorumPeer
     */
    public QuorumPeer getQuorumPeer() {
<span class="nc" id="L501">        return self;</span>
    }

    /**
     * Thread to listen on some port
     */
    public class Listener extends ZooKeeperThread {

<span class="fc" id="L509">        volatile ServerSocket ss = null;</span>

<span class="fc" id="L511">        public Listener() {</span>
            // During startup of thread, thread name will be overridden to
            // specific election address
<span class="fc" id="L514">            super(&quot;ListenerThread&quot;);</span>
<span class="fc" id="L515">        }</span>

        /**
         * Sleeps on accept().
         */
        @Override
        public void run() {
<span class="fc" id="L522">            int numRetries = 0;</span>
            InetSocketAddress addr;
<span class="pc bpc" id="L524" title="1 of 4 branches missed.">            while((!shutdown) &amp;&amp; (numRetries &lt; 3)){</span>
                try {
<span class="fc" id="L526">                    ss = new ServerSocket();</span>
<span class="fc" id="L527">                    ss.setReuseAddress(true);</span>
<span class="pc bpc" id="L528" title="1 of 2 branches missed.">                    if (self.getQuorumListenOnAllIPs()) {</span>
<span class="nc" id="L529">                        int port = self.quorumPeers.get(self.getId()).electionAddr.getPort();</span>
<span class="nc" id="L530">                        addr = new InetSocketAddress(port);</span>
<span class="nc" id="L531">                    } else {</span>
<span class="fc" id="L532">                        addr = self.quorumPeers.get(self.getId()).electionAddr;</span>
                    }
<span class="fc" id="L534">                    LOG.info(&quot;My election bind port: &quot; + addr.toString());</span>
<span class="fc" id="L535">                    setName(self.quorumPeers.get(self.getId()).electionAddr</span>
<span class="fc" id="L536">                            .toString());</span>
<span class="fc" id="L537">                    ss.bind(addr);</span>
<span class="pc bpc" id="L538" title="1 of 2 branches missed.">                    while (!shutdown) {</span>
<span class="fc" id="L539">                        Socket client = ss.accept();</span>
<span class="fc" id="L540">                        setSockOpts(client);</span>
<span class="fc" id="L541">                        LOG.info(&quot;Received connection request &quot;</span>
<span class="fc" id="L542">                                + client.getRemoteSocketAddress());</span>
<span class="fc" id="L543">                        receiveConnection(client);</span>
<span class="fc" id="L544">                        numRetries = 0;</span>
<span class="fc" id="L545">                    }</span>
<span class="fc" id="L546">                } catch (IOException e) {</span>
<span class="fc" id="L547">                    LOG.error(&quot;Exception while listening&quot;, e);</span>
<span class="fc" id="L548">                    numRetries++;</span>
                    try {
<span class="fc" id="L550">                        ss.close();</span>
<span class="fc" id="L551">                        Thread.sleep(1000);</span>
<span class="nc" id="L552">                    } catch (IOException ie) {</span>
<span class="nc" id="L553">                        LOG.error(&quot;Error closing server socket&quot;, ie);</span>
<span class="nc" id="L554">                    } catch (InterruptedException ie) {</span>
<span class="nc" id="L555">                        LOG.error(&quot;Interrupted while sleeping. &quot; +</span>
                                  &quot;Ignoring exception&quot;, ie);
<span class="pc" id="L557">                    }</span>
<span class="pc" id="L558">                }</span>
            }
<span class="fc" id="L560">            LOG.info(&quot;Leaving listener&quot;);</span>
<span class="pc bpc" id="L561" title="1 of 2 branches missed.">            if (!shutdown) {</span>
<span class="nc" id="L562">                LOG.error(&quot;As I'm leaving the listener thread, &quot;</span>
                        + &quot;I won't be able to participate in leader &quot;
                        + &quot;election any longer: &quot;
<span class="nc" id="L565">                        + self.quorumPeers.get(self.getId()).electionAddr);</span>
            }
<span class="fc" id="L567">        }</span>
        
        /**
         * Halts this listener thread.
         */
        void halt(){
            try{
<span class="fc" id="L574">                LOG.debug(&quot;Trying to close listener: &quot; + ss);</span>
<span class="pc bpc" id="L575" title="1 of 2 branches missed.">                if(ss != null) {</span>
<span class="fc" id="L576">                    LOG.debug(&quot;Closing listener: &quot; + self.getId());</span>
<span class="fc" id="L577">                    ss.close();</span>
                }
<span class="nc" id="L579">            } catch (IOException e){</span>
<span class="nc" id="L580">                LOG.warn(&quot;Exception when shutting down listener: &quot; + e);</span>
<span class="fc" id="L581">            }</span>
<span class="fc" id="L582">        }</span>
    }

    /**
     * Thread to send messages. Instance waits on a queue, and send a message as
     * soon as there is one available. If connection breaks, then opens a new
     * one.
     */
    class SendWorker extends ZooKeeperThread {
        Long sid;
        Socket sock;
        RecvWorker recvWorker;
<span class="fc" id="L594">        volatile boolean running = true;</span>
        DataOutputStream dout;

        /**
         * An instance of this thread receives messages to send
         * through a queue and sends them to the server sid.
         * 
         * @param sock
         *            Socket to remote peer
         * @param sid
         *            Server identifier of remote peer
         */
<span class="fc" id="L606">        SendWorker(Socket sock, Long sid) {</span>
<span class="fc" id="L607">            super(&quot;SendWorker:&quot; + sid);</span>
<span class="fc" id="L608">            this.sid = sid;</span>
<span class="fc" id="L609">            this.sock = sock;</span>
<span class="fc" id="L610">            recvWorker = null;</span>
            try {
<span class="fc" id="L612">                dout = new DataOutputStream(sock.getOutputStream());</span>
<span class="nc" id="L613">            } catch (IOException e) {</span>
<span class="nc" id="L614">                LOG.error(&quot;Unable to access socket output stream&quot;, e);</span>
<span class="nc" id="L615">                closeSocket(sock);</span>
<span class="nc" id="L616">                running = false;</span>
<span class="fc" id="L617">            }</span>
<span class="fc" id="L618">            LOG.debug(&quot;Address of remote peer: &quot; + this.sid);</span>
<span class="fc" id="L619">        }</span>

        synchronized void setRecv(RecvWorker recvWorker) {
<span class="fc" id="L622">            this.recvWorker = recvWorker;</span>
<span class="fc" id="L623">        }</span>

        /**
         * Returns RecvWorker that pairs up with this SendWorker.
         * 
         * @return RecvWorker 
         */
        synchronized RecvWorker getRecvWorker(){
<span class="nc" id="L631">            return recvWorker;</span>
        }
                
        synchronized boolean finish() {
<span class="pc bpc" id="L635" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L636">                LOG.debug(&quot;Calling finish for &quot; + sid);</span>
            }
            
<span class="fc bfc" id="L639" title="All 2 branches covered.">            if(!running){</span>
                /*
                 * Avoids running finish() twice. 
                 */
<span class="fc" id="L643">                return running;</span>
            }
            
<span class="fc" id="L646">            running = false;</span>
<span class="fc" id="L647">            closeSocket(sock);</span>
            // channel = null;

<span class="fc" id="L650">            this.interrupt();</span>
<span class="pc bpc" id="L651" title="1 of 2 branches missed.">            if (recvWorker != null) {</span>
<span class="fc" id="L652">                recvWorker.finish();</span>
            }

<span class="pc bpc" id="L655" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L656">                LOG.debug(&quot;Removing entry from senderWorkerMap sid=&quot; + sid);</span>
            }
<span class="fc" id="L658">            senderWorkerMap.remove(sid, this);</span>
<span class="fc" id="L659">            threadCnt.decrementAndGet();</span>
<span class="fc" id="L660">            return running;</span>
        }
        
        synchronized void send(ByteBuffer b) throws IOException {
<span class="fc" id="L664">            byte[] msgBytes = new byte[b.capacity()];</span>
            try {
<span class="fc" id="L666">                b.position(0);</span>
<span class="fc" id="L667">                b.get(msgBytes);</span>
<span class="nc" id="L668">            } catch (BufferUnderflowException be) {</span>
<span class="nc" id="L669">                LOG.error(&quot;BufferUnderflowException &quot;, be);</span>
<span class="nc" id="L670">                return;</span>
<span class="fc" id="L671">            }</span>
<span class="fc" id="L672">            dout.writeInt(b.capacity());</span>
<span class="fc" id="L673">            dout.write(b.array());</span>
<span class="fc" id="L674">            dout.flush();</span>
<span class="fc" id="L675">        }</span>

        @Override
        public void run() {
<span class="fc" id="L679">            threadCnt.incrementAndGet();</span>
            try {
                /**
                 * If there is nothing in the queue to send, then we
                 * send the lastMessage to ensure that the last message
                 * was received by the peer. The message could be dropped
                 * in case self or the peer shutdown their connection
                 * (and exit the thread) prior to reading/processing
                 * the last message. Duplicate messages are handled correctly
                 * by the peer.
                 *
                 * If the send queue is non-empty, then we have a recent
                 * message than that stored in lastMessage. To avoid sending
                 * stale message, we should send the message in the send queue.
                 */
<span class="fc" id="L694">                ArrayBlockingQueue&lt;ByteBuffer&gt; bq = queueSendMap.get(sid);</span>
<span class="pc bpc" id="L695" title="1 of 4 branches missed.">                if (bq == null || isSendQueueEmpty(bq)) {</span>
<span class="fc" id="L696">                   ByteBuffer b = lastMessageSent.get(sid);</span>
<span class="fc bfc" id="L697" title="All 2 branches covered.">                   if (b != null) {</span>
<span class="fc" id="L698">                       LOG.debug(&quot;Attempting to send lastMessage to sid=&quot; + sid);</span>
<span class="fc" id="L699">                       send(b);</span>
                   }
                }
<span class="fc" id="L702">            } catch (IOException e) {</span>
<span class="fc" id="L703">                LOG.error(&quot;Failed to send last message. Shutting down thread.&quot;, e);</span>
<span class="fc" id="L704">                this.finish();</span>
<span class="fc" id="L705">            }</span>
            
            try {
<span class="pc bpc" id="L708" title="1 of 6 branches missed.">                while (running &amp;&amp; !shutdown &amp;&amp; sock != null) {</span>

<span class="fc" id="L710">                    ByteBuffer b = null;</span>
                    try {
<span class="fc" id="L712">                        ArrayBlockingQueue&lt;ByteBuffer&gt; bq = queueSendMap</span>
<span class="fc" id="L713">                                .get(sid);</span>
<span class="pc bpc" id="L714" title="1 of 2 branches missed.">                        if (bq != null) {</span>
<span class="fc" id="L715">                            b = pollSendQueue(bq, 1000, TimeUnit.MILLISECONDS);</span>
                        } else {
<span class="nc" id="L717">                            LOG.error(&quot;No queue of incoming messages for &quot; +</span>
                                      &quot;server &quot; + sid);
<span class="nc" id="L719">                            break;</span>
                        }

<span class="fc bfc" id="L722" title="All 2 branches covered.">                        if(b != null){</span>
<span class="fc" id="L723">                            lastMessageSent.put(sid, b);</span>
<span class="fc" id="L724">                            send(b);</span>
                        }
<span class="fc" id="L726">                    } catch (InterruptedException e) {</span>
<span class="fc" id="L727">                        LOG.warn(&quot;Interrupted while waiting for message on queue&quot;,</span>
                                e);
<span class="fc" id="L729">                    }</span>
<span class="fc" id="L730">                }</span>
<span class="fc" id="L731">            } catch (Exception e) {</span>
<span class="fc" id="L732">                LOG.warn(&quot;Exception when using channel: for id &quot; + sid + &quot; my id = &quot; + </span>
<span class="fc" id="L733">                        self.getId() + &quot; error = &quot; + e);</span>
<span class="fc" id="L734">            }</span>
<span class="fc" id="L735">            this.finish();</span>
<span class="fc" id="L736">            LOG.warn(&quot;Send worker leaving thread&quot;);</span>
<span class="fc" id="L737">        }</span>
    }

    /**
     * Thread to receive messages. Instance waits on a socket read. If the
     * channel breaks, then removes itself from the pool of receivers.
     */
    class RecvWorker extends ZooKeeperThread {
        Long sid;
        Socket sock;
<span class="fc" id="L747">        volatile boolean running = true;</span>
        DataInputStream din;
        final SendWorker sw;

<span class="fc" id="L751">        RecvWorker(Socket sock, Long sid, SendWorker sw) {</span>
<span class="fc" id="L752">            super(&quot;RecvWorker:&quot; + sid);</span>
<span class="fc" id="L753">            this.sid = sid;</span>
<span class="fc" id="L754">            this.sock = sock;</span>
<span class="fc" id="L755">            this.sw = sw;</span>
            try {
<span class="fc" id="L757">                din = new DataInputStream(sock.getInputStream());</span>
                // OK to wait until socket disconnects while reading.
<span class="fc" id="L759">                sock.setSoTimeout(0);</span>
<span class="nc" id="L760">            } catch (IOException e) {</span>
<span class="nc" id="L761">                LOG.error(&quot;Error while accessing socket for &quot; + sid, e);</span>
<span class="nc" id="L762">                closeSocket(sock);</span>
<span class="nc" id="L763">                running = false;</span>
<span class="fc" id="L764">            }</span>
<span class="fc" id="L765">        }</span>
        
        /**
         * Shuts down this worker
         * 
         * @return boolean  Value of variable running
         */
        synchronized boolean finish() {
<span class="pc bpc" id="L773" title="1 of 2 branches missed.">            if(!running){</span>
                /*
                 * Avoids running finish() twice. 
                 */
<span class="nc" id="L777">                return running;</span>
            }
<span class="fc" id="L779">            running = false;            </span>

<span class="fc" id="L781">            this.interrupt();</span>
<span class="fc" id="L782">            threadCnt.decrementAndGet();</span>
<span class="fc" id="L783">            return running;</span>
        }

        @Override
        public void run() {
<span class="fc" id="L788">            threadCnt.incrementAndGet();</span>
            try {
<span class="pc bpc" id="L790" title="2 of 6 branches missed.">                while (running &amp;&amp; !shutdown &amp;&amp; sock != null) {</span>
                    /**
                     * Reads the first int to determine the length of the
                     * message
                     */
<span class="fc" id="L795">                    int length = din.readInt();</span>
<span class="pc bpc" id="L796" title="1 of 4 branches missed.">                    if (length &lt;= 0 || length &gt; PACKETMAXSIZE) {</span>
<span class="fc" id="L797">                        throw new IOException(</span>
                                &quot;Received packet with invalid packet: &quot;
                                        + length);
                    }
                    /**
                     * Allocates a new ByteBuffer to receive the message
                     */
<span class="fc" id="L804">                    byte[] msgArray = new byte[length];</span>
<span class="fc" id="L805">                    din.readFully(msgArray, 0, length);</span>
<span class="fc" id="L806">                    ByteBuffer message = ByteBuffer.wrap(msgArray);</span>
<span class="fc" id="L807">                    addToRecvQueue(new Message(message.duplicate(), sid));</span>
<span class="fc" id="L808">                }</span>
<span class="fc" id="L809">            } catch (Exception e) {</span>
<span class="fc" id="L810">                LOG.warn(&quot;Connection broken for id &quot; + sid + &quot;, my id = &quot; + </span>
<span class="fc" id="L811">                        self.getId() + &quot;, error = &quot; , e);</span>
<span class="fc" id="L812">            } finally {</span>
<span class="nc" id="L813">                LOG.warn(&quot;Interrupting SendWorker&quot;);</span>
<span class="pc" id="L814">                sw.finish();</span>
<span class="pc bpc" id="L815" title="4 of 6 branches missed.">                if (sock != null) {</span>
<span class="pc" id="L816">                    closeSocket(sock);</span>
                }
<span class="fc" id="L818">            }</span>
<span class="fc" id="L819">        }</span>
    }

    /**
     * Inserts an element in the specified queue. If the Queue is full, this
     * method removes an element from the head of the Queue and then inserts
     * the element at the tail. It can happen that the an element is removed
     * by another thread in {@link SendWorker#processMessage() processMessage}
     * method before this method attempts to remove an element from the queue.
     * This will cause {@link ArrayBlockingQueue#remove() remove} to throw an
     * exception, which is safe to ignore.
     *
     * Unlike {@link #addToRecvQueue(Message) addToRecvQueue} this method does
     * not need to be synchronized since there is only one thread that inserts
     * an element in the queue and another thread that reads from the queue.
     *
     * @param queue
     *          Reference to the Queue
     * @param buffer
     *          Reference to the buffer to be inserted in the queue
     */
    private void addToSendQueue(ArrayBlockingQueue&lt;ByteBuffer&gt; queue,
          ByteBuffer buffer) {
<span class="fc bfc" id="L842" title="All 2 branches covered.">        if (queue.remainingCapacity() == 0) {</span>
            try {
<span class="fc" id="L844">                queue.remove();</span>
<span class="nc" id="L845">            } catch (NoSuchElementException ne) {</span>
                // element could be removed by poll()
<span class="nc" id="L847">                LOG.debug(&quot;Trying to remove from an empty &quot; +</span>
                        &quot;Queue. Ignoring exception &quot; + ne);
<span class="fc" id="L849">            }</span>
        }
        try {
<span class="fc" id="L852">            queue.add(buffer);</span>
<span class="nc" id="L853">        } catch (IllegalStateException ie) {</span>
            // This should never happen
<span class="nc" id="L855">            LOG.error(&quot;Unable to insert an element in the queue &quot; + ie);</span>
<span class="fc" id="L856">        }</span>
<span class="fc" id="L857">    }</span>

    /**
     * Returns true if queue is empty.
     * @param queue
     *          Reference to the queue
     * @return
     *      true if the specified queue is empty
     */
    private boolean isSendQueueEmpty(ArrayBlockingQueue&lt;ByteBuffer&gt; queue) {
<span class="fc" id="L867">        return queue.isEmpty();</span>
    }

    /**
     * Retrieves and removes buffer at the head of this queue,
     * waiting up to the specified wait time if necessary for an element to
     * become available.
     *
     * {@link ArrayBlockingQueue#poll(long, java.util.concurrent.TimeUnit)}
     */
    private ByteBuffer pollSendQueue(ArrayBlockingQueue&lt;ByteBuffer&gt; queue,
          long timeout, TimeUnit unit) throws InterruptedException {
<span class="fc" id="L879">       return queue.poll(timeout, unit);</span>
    }

    /**
     * Inserts an element in the {@link #recvQueue}. If the Queue is full, this
     * methods removes an element from the head of the Queue and then inserts
     * the element at the tail of the queue.
     *
     * This method is synchronized to achieve fairness between two threads that
     * are trying to insert an element in the queue. Each thread checks if the
     * queue is full, then removes the element at the head of the queue, and
     * then inserts an element at the tail. This three-step process is done to
     * prevent a thread from blocking while inserting an element in the queue.
     * If we do not synchronize the call to this method, then a thread can grab
     * a slot in the queue created by the second thread. This can cause the call
     * to insert by the second thread to fail.
     * Note that synchronizing this method does not block another thread
     * from polling the queue since that synchronization is provided by the
     * queue itself.
     *
     * @param msg
     *          Reference to the message to be inserted in the queue
     */
    public void addToRecvQueue(Message msg) {
<span class="fc" id="L903">        synchronized(recvQLock) {</span>
<span class="pc bpc" id="L904" title="1 of 2 branches missed.">            if (recvQueue.remainingCapacity() == 0) {</span>
                try {
<span class="nc" id="L906">                    recvQueue.remove();</span>
<span class="nc" id="L907">                } catch (NoSuchElementException ne) {</span>
                    // element could be removed by poll()
<span class="nc" id="L909">                     LOG.debug(&quot;Trying to remove from an empty &quot; +</span>
                         &quot;recvQueue. Ignoring exception &quot; + ne);
<span class="nc" id="L911">                }</span>
            }
            try {
<span class="fc" id="L914">                recvQueue.add(msg);</span>
<span class="nc" id="L915">            } catch (IllegalStateException ie) {</span>
                // This should never happen
<span class="nc" id="L917">                LOG.error(&quot;Unable to insert element in the recvQueue &quot; + ie);</span>
<span class="fc" id="L918">            }</span>
<span class="pc" id="L919">        }</span>
<span class="fc" id="L920">    }</span>

    /**
     * Retrieves and removes a message at the head of this queue,
     * waiting up to the specified wait time if necessary for an element to
     * become available.
     *
     * {@link ArrayBlockingQueue#poll(long, java.util.concurrent.TimeUnit)}
     */
    public Message pollRecvQueue(long timeout, TimeUnit unit)
       throws InterruptedException {
<span class="fc" id="L931">       return recvQueue.poll(timeout, unit);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>